
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

yarip.List = function(name)
{
	this.name = "";
	this.xpaths = {};
	this.length = 0;
//	this.changesMade = false;

/*	this.setChanged = function()
	{
		this.changesMade = true;
	}

	this.resetChanged = function()
	{
		this.changesMade = false;
	}*/

	this.setName = function(name)
	{
		if (name) this.name = "" + name;
	}

	this.add = function(xpath)
	{
		if (!xpath) return;
		if (!this.xpaths[xpath.value]) this.length++;
		this.xpaths[xpath.value] = xpath;
//		this.changesMade = true;
	}

	this.remove = function(xpath)
	{
		if (!xpath || !this.xpaths[xpath.value]) return;
		this.xpaths[xpath.value] = null;
		this.length--;
//		this.changesMade = true;
	}

	this.reset = function()
	{
		this.xpaths = {};
		this.length = 0;
//		this.changesMade = false;
	}

	this.getXPathsArray = function()
	{
		var aXPaths = [];
		for (var v in this.xpaths)
		{
			var xpath = this.xpaths[v];
			if (xpath) aXPaths[aXPaths.length] = [v, xpath.getDeep(), xpath.getFound(), xpath.getNotFound(), xpath.getWhitelisted()];
		}
		return aXPaths;
	}

	this.sortXPaths = function(reduce)
	{
//		if (!this.changesMade) return;
		var xArr = [];
		for (var v in this.xpaths) if (this.xpaths[v]) xArr.push(this.xpaths[v]);
		xArr.sort(yarip.XPathSorter);

		if (reduce)
		{

			var rArr = [];
			var tArr = [];
			var xpath = xArr.shift();
			while (xpath)
			{
				rArr.push(xpath);
				for (var i = 0; i < xArr.length; i++)
				{
					if (
						xArr[i].value.indexOf(xpath.value) != 0 // does not contain
						|| xArr[i].value.charAt(xpath.value.length) != "/" // is not a special symbol
					) tArr.push(xArr[i]);
				}
				xArr = tArr;
				tArr = [];
				xpath = xArr.shift();
			}
			xArr = rArr;
			this.reset();

		}

		for (var i = 0; i < xArr.length; i++) if (xArr[i]) this.add(xArr[i]);
//		this.changesMade = false;
	}

	this.clone = function(purge)
	{
		var list = new this.constructor(this.name);
		for (var v in this.xpaths) if (this.xpaths[v]) list.add(this.xpaths[v].clone(purge));
		return list;
	}

	this.generateXml = function()
	{
		var r = "";
		var tmp = "";
		for (var v in this.xpaths)
		{
			if (!this.xpaths[v]) continue;
			tmp += this.xpaths[v].generateXml();
		}
		if (tmp != "") r += "\t\t<" + this.name + ">\n" + tmp + "\t\t</" + this.name + ">\n";
		return r;
	}

	this.setName(name);
}
